library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity fontrom128_64 is
	port (
		Clk : in std_logic;
		en : in std_logic;
		addr : in std_logic_vector( 15 downto 0 );
		hline : in std_logic_vector( 2 downto 0 );
		data : out std_logic_vector( 15 downto 0 )
	);
end fontrom128_64;

architecture imp of fontrom128_64 is 
	type rom_type is array( 0 to 1023) of 
		std_logic_vector( 7 downto 0 );
	constant ROM : rom_type := (
		X"00",
		X"7e",
		X"7e",
		X"6c",
		X"10",
		X"38",
		X"10",
		X"00",
		X"ff",
		X"00",
		X"ff",
		X"0f",
		X"3c",
		X"3f",
		X"7f",
		X"18",
		X"80",
		X"02",
		X"18",
		X"66",
		X"7f",
		X"3e",
		X"00",
		X"18",
		X"18",
		X"18",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"18",
		X"66",
		X"6c",
		X"18",
		X"00",
		X"38",
		X"18",
		X"0c",
		X"30",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"06",
		X"38",
		X"18",
		X"7c",
		X"7c",
		X"1c",
		X"fe",
		X"38",
		X"fe",
		X"7c",
		X"7c",
		X"00",
		X"00",
		X"06",
		X"00",
		X"60",
		X"7c",
		X"7c",
		X"38",
		X"fc",
		X"3c",
		X"f8",
		X"fe",
		X"fe",
		X"3c",
		X"c6",
		X"3c",
		X"1e",
		X"e6",
		X"f0",
		X"c6",
		X"c6",
		X"7c",
		X"fc",
		X"7c",
		X"fc",
		X"3c",
		X"7e",
		X"c6",
		X"c6",
		X"c6",
		X"c6",
		X"66",
		X"fe",
		X"3c",
		X"c0",
		X"3c",
		X"10",
		X"00",
		X"30",
		X"00",
		X"e0",
		X"00",
		X"1c",
		X"00",
		X"3c",
		X"00",
		X"e0",
		X"18",
		X"06",
		X"e0",
		X"38",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"30",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"0e",
		X"18",
		X"70",
		X"76",
		X"00",
		X"00",
		X"81",
		X"ff",
		X"fe",
		X"38",
		X"7c",
		X"38",
		X"00",
		X"ff",
		X"3c",
		X"c3",
		X"07",
		X"66",
		X"33",
		X"63",
		X"db",
		X"e0",
		X"0e",
		X"3c",
		X"66",
		X"db",
		X"61",
		X"00",
		X"3c",
		X"3c",
		X"18",
		X"18",
		X"30",
		X"00",
		X"24",
		X"18",
		X"ff",
		X"00",
		X"3c",
		X"66",
		X"6c",
		X"3e",
		X"c6",
		X"6c",
		X"18",
		X"18",
		X"18",
		X"66",
		X"18",
		X"00",
		X"00",
		X"00",
		X"0c",
		X"6c",
		X"38",
		X"c6",
		X"c6",
		X"3c",
		X"c0",
		X"60",
		X"c6",
		X"c6",
		X"c6",
		X"18",
		X"18",
		X"0c",
		X"00",
		X"30",
		X"c6",
		X"c6",
		X"6c",
		X"66",
		X"66",
		X"6c",
		X"62",
		X"62",
		X"66",
		X"c6",
		X"18",
		X"0c",
		X"66",
		X"60",
		X"ee",
		X"e6",
		X"c6",
		X"66",
		X"c6",
		X"66",
		X"66",
		X"7e",
		X"c6",
		X"c6",
		X"c6",
		X"c6",
		X"66",
		X"c6",
		X"30",
		X"60",
		X"0c",
		X"38",
		X"00",
		X"18",
		X"00",
		X"60",
		X"00",
		X"0c",
		X"00",
		X"66",
		X"00",
		X"60",
		X"00",
		X"00",
		X"60",
		X"18",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"30",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"18",
		X"18",
		X"18",
		X"dc",
		X"10",
		X"00",
		X"a5",
		X"db",
		X"fe",
		X"7c",
		X"38",
		X"7c",
		X"18",
		X"e7",
		X"66",
		X"99",
		X"0f",
		X"66",
		X"3f",
		X"7f",
		X"3c",
		X"f8",
		X"3e",
		X"7e",
		X"66",
		X"db",
		X"3c",
		X"00",
		X"7e",
		X"7e",
		X"18",
		X"0c",
		X"60",
		X"c0",
		X"66",
		X"3c",
		X"ff",
		X"00",
		X"3c",
		X"24",
		X"fe",
		X"60",
		X"cc",
		X"38",
		X"30",
		X"30",
		X"0c",
		X"3c",
		X"18",
		X"00",
		X"00",
		X"00",
		X"18",
		X"c6",
		X"18",
		X"06",
		X"06",
		X"6c",
		X"c0",
		X"c0",
		X"0c",
		X"c6",
		X"c6",
		X"18",
		X"18",
		X"18",
		X"7e",
		X"18",
		X"0c",
		X"de",
		X"c6",
		X"66",
		X"c0",
		X"66",
		X"68",
		X"68",
		X"c0",
		X"c6",
		X"18",
		X"0c",
		X"6c",
		X"60",
		X"fe",
		X"f6",
		X"c6",
		X"66",
		X"c6",
		X"66",
		X"30",
		X"5a",
		X"c6",
		X"c6",
		X"c6",
		X"6c",
		X"66",
		X"8c",
		X"30",
		X"30",
		X"0c",
		X"6c",
		X"00",
		X"0c",
		X"78",
		X"7c",
		X"7c",
		X"7c",
		X"7c",
		X"60",
		X"76",
		X"6c",
		X"38",
		X"06",
		X"66",
		X"18",
		X"ec",
		X"dc",
		X"7c",
		X"dc",
		X"76",
		X"dc",
		X"7e",
		X"fc",
		X"cc",
		X"c6",
		X"c6",
		X"c6",
		X"c6",
		X"7e",
		X"18",
		X"18",
		X"18",
		X"00",
		X"38",
		X"00",
		X"81",
		X"ff",
		X"fe",
		X"fe",
		X"fe",
		X"fe",
		X"3c",
		X"c3",
		X"42",
		X"bd",
		X"7d",
		X"66",
		X"30",
		X"63",
		X"e7",
		X"fe",
		X"fe",
		X"18",
		X"66",
		X"7b",
		X"66",
		X"00",
		X"18",
		X"18",
		X"18",
		X"fe",
		X"fe",
		X"c0",
		X"ff",
		X"7e",
		X"7e",
		X"00",
		X"18",
		X"00",
		X"6c",
		X"3c",
		X"18",
		X"76",
		X"00",
		X"30",
		X"0c",
		X"ff",
		X"7e",
		X"00",
		X"7e",
		X"00",
		X"30",
		X"d6",
		X"18",
		X"1c",
		X"3c",
		X"cc",
		X"fc",
		X"fc",
		X"18",
		X"7c",
		X"7e",
		X"00",
		X"00",
		X"30",
		X"00",
		X"0c",
		X"18",
		X"de",
		X"fe",
		X"7c",
		X"c0",
		X"66",
		X"78",
		X"78",
		X"c0",
		X"fe",
		X"18",
		X"0c",
		X"78",
		X"60",
		X"fe",
		X"de",
		X"c6",
		X"7c",
		X"c6",
		X"7c",
		X"18",
		X"18",
		X"c6",
		X"c6",
		X"d6",
		X"38",
		X"3c",
		X"18",
		X"30",
		X"18",
		X"0c",
		X"c6",
		X"00",
		X"00",
		X"0c",
		X"66",
		X"c6",
		X"cc",
		X"c6",
		X"f8",
		X"cc",
		X"76",
		X"18",
		X"06",
		X"6c",
		X"18",
		X"fe",
		X"66",
		X"c6",
		X"66",
		X"cc",
		X"76",
		X"c0",
		X"30",
		X"cc",
		X"c6",
		X"d6",
		X"6c",
		X"c6",
		X"4c",
		X"70",
		X"18",
		X"0e",
		X"00",
		X"6c",
		X"00",
		X"bd",
		X"c3",
		X"7c",
		X"7c",
		X"fe",
		X"fe",
		X"3c",
		X"c3",
		X"42",
		X"bd",
		X"cc",
		X"3c",
		X"30",
		X"63",
		X"e7",
		X"f8",
		X"3e",
		X"18",
		X"66",
		X"1b",
		X"66",
		X"7e",
		X"7e",
		X"18",
		X"7e",
		X"0c",
		X"60",
		X"c0",
		X"66",
		X"ff",
		X"3c",
		X"00",
		X"18",
		X"00",
		X"fe",
		X"06",
		X"30",
		X"dc",
		X"00",
		X"30",
		X"0c",
		X"3c",
		X"18",
		X"00",
		X"00",
		X"00",
		X"60",
		X"c6",
		X"18",
		X"30",
		X"06",
		X"fe",
		X"06",
		X"c6",
		X"30",
		X"c6",
		X"06",
		X"00",
		X"00",
		X"18",
		X"00",
		X"18",
		X"18",
		X"de",
		X"c6",
		X"66",
		X"c0",
		X"66",
		X"68",
		X"68",
		X"ce",
		X"c6",
		X"18",
		X"cc",
		X"6c",
		X"62",
		X"d6",
		X"ce",
		X"c6",
		X"60",
		X"c6",
		X"6c",
		X"0c",
		X"18",
		X"c6",
		X"c6",
		X"d6",
		X"6c",
		X"18",
		X"32",
		X"30",
		X"0c",
		X"0c",
		X"00",
		X"00",
		X"00",
		X"7c",
		X"66",
		X"c0",
		X"cc",
		X"fe",
		X"60",
		X"cc",
		X"66",
		X"18",
		X"06",
		X"78",
		X"18",
		X"d6",
		X"66",
		X"c6",
		X"66",
		X"cc",
		X"60",
		X"7c",
		X"30",
		X"cc",
		X"c6",
		X"d6",
		X"38",
		X"c6",
		X"18",
		X"18",
		X"18",
		X"18",
		X"00",
		X"c6",
		X"00",
		X"99",
		X"e7",
		X"38",
		X"38",
		X"d6",
		X"7c",
		X"18",
		X"e7",
		X"66",
		X"99",
		X"cc",
		X"18",
		X"70",
		X"67",
		X"3c",
		X"e0",
		X"0e",
		X"7e",
		X"00",
		X"1b",
		X"3c",
		X"7e",
		X"3c",
		X"18",
		X"3c",
		X"18",
		X"30",
		X"fe",
		X"24",
		X"ff",
		X"18",
		X"00",
		X"00",
		X"00",
		X"6c",
		X"7c",
		X"66",
		X"cc",
		X"00",
		X"18",
		X"18",
		X"66",
		X"18",
		X"18",
		X"00",
		X"18",
		X"c0",
		X"6c",
		X"18",
		X"66",
		X"c6",
		X"0c",
		X"c6",
		X"c6",
		X"30",
		X"c6",
		X"0c",
		X"18",
		X"18",
		X"0c",
		X"7e",
		X"30",
		X"00",
		X"c0",
		X"c6",
		X"66",
		X"66",
		X"6c",
		X"62",
		X"60",
		X"66",
		X"c6",
		X"18",
		X"cc",
		X"66",
		X"66",
		X"c6",
		X"c6",
		X"c6",
		X"60",
		X"ce",
		X"66",
		X"66",
		X"18",
		X"c6",
		X"6c",
		X"fe",
		X"c6",
		X"18",
		X"66",
		X"30",
		X"06",
		X"0c",
		X"00",
		X"00",
		X"00",
		X"cc",
		X"66",
		X"c6",
		X"cc",
		X"c0",
		X"60",
		X"7c",
		X"66",
		X"18",
		X"66",
		X"6c",
		X"18",
		X"d6",
		X"66",
		X"c6",
		X"7c",
		X"7c",
		X"60",
		X"06",
		X"36",
		X"cc",
		X"6c",
		X"fe",
		X"6c",
		X"7e",
		X"32",
		X"18",
		X"18",
		X"18",
		X"00",
		X"c6",
		X"00",
		X"81",
		X"ff",
		X"10",
		X"10",
		X"10",
		X"10",
		X"00",
		X"ff",
		X"3c",
		X"c3",
		X"cc",
		X"7e",
		X"f0",
		X"e6",
		X"db",
		X"80",
		X"02",
		X"3c",
		X"66",
		X"1b",
		X"86",
		X"7e",
		X"18",
		X"18",
		X"18",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"18",
		X"00",
		X"6c",
		X"18",
		X"c6",
		X"76",
		X"00",
		X"0c",
		X"30",
		X"00",
		X"00",
		X"18",
		X"00",
		X"18",
		X"80",
		X"38",
		X"7e",
		X"fe",
		X"7c",
		X"1e",
		X"7c",
		X"7c",
		X"30",
		X"7c",
		X"78",
		X"18",
		X"18",
		X"06",
		X"00",
		X"60",
		X"18",
		X"78",
		X"c6",
		X"fc",
		X"3c",
		X"f8",
		X"fe",
		X"f0",
		X"3a",
		X"c6",
		X"3c",
		X"78",
		X"e6",
		X"fe",
		X"c6",
		X"c6",
		X"7c",
		X"f0",
		X"7c",
		X"e6",
		X"3c",
		X"3c",
		X"7c",
		X"38",
		X"6c",
		X"c6",
		X"3c",
		X"fe",
		X"3c",
		X"02",
		X"3c",
		X"00",
		X"00",
		X"00",
		X"76",
		X"dc",
		X"7c",
		X"76",
		X"7c",
		X"f0",
		X"0c",
		X"e6",
		X"3c",
		X"66",
		X"e6",
		X"3c",
		X"d6",
		X"66",
		X"7c",
		X"60",
		X"0c",
		X"f0",
		X"fc",
		X"1c",
		X"76",
		X"38",
		X"6c",
		X"c6",
		X"06",
		X"7e",
		X"0e",
		X"18",
		X"70",
		X"00",
		X"fe",
		X"00",
		X"7e",
		X"7e",
		X"00",
		X"00",
		X"38",
		X"38",
		X"00",
		X"ff",
		X"00",
		X"ff",
		X"78",
		X"18",
		X"e0",
		X"c0",
		X"18",
		X"00",
		X"00",
		X"18",
		X"00",
		X"00",
		X"7c",
		X"00",
		X"ff",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"30",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"30",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"0e",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"ff",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"f8",
		X"00",
		X"00",
		X"3c",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"f0",
		X"1e",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"fc",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00",
		X"00"
	);
begin

process( Clk )
begin
  if( Clk'event and Clk = '1' ) then
    if( en = '1' ) then
      data <= (ROM( conv_integer( hline & addr( 14 downto 8 ))) & ROM( conv_integer(hline & addr( 6 downto 0 ))));
      --data <= not(ROM( conv_integer( addr( 14 downto 8 ) & hline)) & ROM( conv_integer(addr( 6 downto 0 ) & hline )));
      --data <= ROM(1015+conv_integer(hline)) & ROM(1015+conv_integer(hline));
    end if;
  end if;
end process;
end imp;
